
"""
solve script for cocos, also callable from system
"""

import sys
import os
import shutil
import subprocess

def solve(argv):
    """
    solve script for cocos: arguments:
    <sourcedir> <targetdir> <plistfile> <solverdir> <languagedir> <timeout> 
    """
    scriptname=argv[0]
    sourcedir=argv[1]
    targetdir=argv[2]
    plistfile=argv[3]
    solverdir=argv[4]
    languagedir=argv[5]
    if len(argv)>6: timeout=argv[6]
    else: timeout='1e6'
    if len(argv)>7: strategy=argv[7]
    else: strategy=''

    try:
        f=open(os.path.join(sourcedir,plistfile),'r')
    except IOError, errmsg:
        print errmsg
    lines=f.readlines()
    f.close()
    for i in lines:
        if i.find('.dag')!=-1:
            filein=i.replace('\n','')
            filetmp=os.path.join(sourcedir,os.path.basename(i).replace('.dag','.res'))
            filetmp=filetmp.replace('\n','')
            fileout=os.path.join(targetdir,os.path.basename(i).replace('.dag','.res'))
            fileout=fileout.replace('\n','')

            comm=''
            commstrlist=[]
            commstrlist.append(os.path.join(solverdir,'cocos'))
            commstrlist.append(' -hopt +ipopt +bs +linrelslp +lpsolve +sbox +paidcoco -t ')
            commstrlist.append(timeout)
            commstrlist.append(' ')
            commstrlist.append(filein)
            comm=comm.join(commstrlist)

            cwd=os.getcwd()
            os.chdir(sourcedir)
            retcode=subprocess.call(comm,shell=True)
            try:
                shutil.move(filetmp,fileout)
            except IOError, errmsg:
                print errmsg
#                filetmp=filetmp.replace('.res','.tim')
#                fileout=fileout.replace('.res','.tim')
#                shutil.move(filetmp,fileout)
                f2=open(fileout,'w')
                f2.write('modelstatus = 2\nx(1) = 0\nobj = 0\ninfeas = 0\nnonopt=1\ntime = 0\nproduced by cocos error\n')
                f2.close()
            os.chdir(cwd)

if __name__=='__main__':
  solve(sys.argv)

