
"""
solve script for coin, also callable from system
"""

import sys
import os
import shutil
import subprocess

def solve(argv):
    """
    solve script for coin, arguments:
    <sourcedir> <targetdir> <plistfile> <solverdir> <languagedir> <timeout> <strategy>
    """
    scriptname=argv[0]
    sourcedir=argv[1]
    targetdir=argv[2]
    plistfile=argv[3]
    solverdir=argv[4]
    languagedir=argv[5]
    if len(argv)>6: timeout=argv[6]
    else: timeout='1e6'
    if len(argv)>7: strategy=argv[7]
    else: strategy=''
    # print("->",scriptname," <X> ",sourcedir," <X> ",targetdir," <X> ",plistfile," <X> ",solverdir," <X> ",languagedir," <X> ",timeout," <X> ",strategy)
    try:
        f=open(os.path.join(sourcedir,plistfile),'r')
    except IOError, errmsg:
        print errmsg
    lines=f.readlines()
    f.close()

    for i in lines:
        if i.find('.gms')!=-1:
            filein=i.replace('\n','')
            filetmp=filein.replace('.gms','_tmp.gms')
            filetmpopt1=os.path.join(sourcedir,'coinipopt.opt')
            filetmpopt2=os.path.join(sourcedir,'coinbonmin.opt')
            fileout=os.path.join(targetdir,os.path.basename(i).replace('.gms','.lst'))
            fileout=fileout.replace('\n','')
            
            f2=open(filetmpopt1,'w')
            f2.write('\n\n')
            f2.close()

            f2=open(filetmpopt2,'w')
            f2.write('time_limit ')
            f2.write(timeout)
            f2.write('\n')
            f2.close()

            f2=open(filetmp,'w')
            f2.write('\noptions nlp = coinipopt, minlp = coinbonmin, dnlp = coinipopt, decimals = 8, limrow = 0, limcol = 0, sysout = on, optca=1e-6, optcr=0, reslim=')
            f2.write(timeout)
            f2.write(';\n\n')
            f3=open(filein,'r')
            f3lines=f3.readlines()
            f3.close()
            for j in f3lines:
                f2.write(j)
            f2.close()

            comm=''
            commstrlist=[]
            commstrlist.append(os.path.join(languagedir,'gams'))
            commstrlist.append(' "')
            commstrlist.append(filetmp)
            commstrlist.append('" -o "')
            commstrlist.append(fileout)
            commstrlist.append('"')
            comm=comm.join(commstrlist)

            cwd=os.getcwd()
            os.chdir(sourcedir)
            retcode=subprocess.call(comm,shell=True)
            os.chdir(cwd)

            os.remove(filetmpopt1)
            os.remove(filetmpopt2)
            os.remove(filetmp)

if __name__=='__main__':
  solve(sys.argv)
