
"""
solve script for KNITRO, also callable from system
"""

import sys
import os
import shutil
import subprocess

def solve(argv):
    """
    solve script for KNITRO, arguments:
    <sourcedir> <targetdir> <plistfile> <solverdir> <languagedir> <timeout> 
    """
    scriptname=argv[0]
    sourcedir=argv[1]
    targetdir=argv[2]
    plistfile=argv[3]
    solverdir=argv[4]
    languagedir=argv[5]
    if len(argv)>6: timeout=argv[6]
    else: timeout='1e6'
    if len(argv)>7: strategy=argv[7]
    else: strategy=''

    try:
        f=open(os.path.join(sourcedir,plistfile),'r')
    except IOError, errmsg:
        print errmsg
    lines=f.readlines()
    f.close()
    for i in lines:
        if i.find('.mod')!=-1:
            filein=i.replace('\n','')
            filetmp=filein.replace('.mod','_tmp.mod')
            fileout=os.path.join(targetdir,os.path.basename(i).replace('.mod','.lst'))
            fileout=fileout.replace('\n','')
            shutil.copy(filein,filetmp)
            f2=open(filetmp,'a')
            f2.write('\noption presolve 0;\noption solver "')
            f2.write(os.path.join(solverdir,'knitroampl'))
            f2.write('";\noption knitro_options \'maxit=1000000000 maxtime_cpu=')
            f2.write(timeout)
            f2.write(' outlev=5 outmode=0\';\nsolve;\n')
            f2.close()
            comm=''
            commstrlist=[]
            commstrlist.append(os.path.join(languagedir,'ampl'))
            commstrlist.append(' "')
            commstrlist.append(filetmp)
            commstrlist.append('" > "')
            commstrlist.append(fileout)
            commstrlist.append('"')
            comm=comm.join(commstrlist)
            retcode=subprocess.call(comm,shell=True)
            os.remove(filetmp)

if __name__=='__main__':
  solve(sys.argv)
