
"""
analyze script for lindoglobal, also callable from system
tailored for dag2gams output problems
"""

import sys
import os

def analyze(argv):
    """
    analyze script for lindoglobal, arguments:
    <sourcedir> <targetdir> <plistfile> (unused: <solverdir> <languagedir> <timeout> <strategy>)
    """
    scriptname=argv[0]
    sourcedir=argv[1]
    targetdir=argv[2]
    plistfile=argv[3]
    try:
        f=open(os.path.join(sourcedir,plistfile),'r')
    except IOError, errmsg:
        print errmsg
    lines=f.readlines()
    f.close()
    for i in lines:
        if i.find('.lst')!=-1:
            filein=i.replace('\n','')
            fileout=os.path.join(targetdir,os.path.basename(i).replace('.lst','.res'))
            fileout=fileout.replace('\n','')

            f1=open(filein,'r')
            lines1=f1.readlines()
            f1.close()

            f2=open(fileout,'w')

            modelstatus=2
            solstart=0
            allzero=0
            timefound=0
            objstr='0'
            tsplit='0'
            for j in lines1:
                # determine model status:
                if str.lower(j).find('**** model status')!=-1:
                    if str.lower(j)=='**** model status      1 optimal                   \n':
                        modelstatus=0
                    elif str.lower(j)=='**** model status      2 locally optimal           \n':
                        modelstatus=1
                    elif str.lower(j)=='**** model status      8 integer solution          \n':
                        modelstatus=1
                    elif str.lower(j)=='**** model status      19 infeasible - no solution \n':
                        modelstatus=-3
                    elif str.lower(j)=='**** model status      5 locally infeasible        \n':
                        modelstatus=2
                    elif str.lower(j)=='**** model status      7 intermediate nonoptimal   \n':
                        modelstatus=2
                    elif str.lower(j)=='**** model status      11 licensing problem        \n':
                        modelstatus=3
                    elif str.lower(j)=='**** model status      error no solution           \n':
                        modelstatus=2
                if (str.lower(j).find('**** user error(s) encountered')!=-1) | (str.lower(j).find('cannot handle function ')!=-1):
                    modelstatus=3
                # find solution strings:
                if j.find('Set j/1*')!=-1:
                    starsplit=j.split('*')[1].split('/')[0]
                    nvar=int(starsplit)
                    x=list(range(nvar))
                    varfound=list(range(nvar))
                    for ind,jj in enumerate(x):
                        x[ind]=0
                        varfound[ind]=0
                if j.find('VARIABLE x.L')!=-1:
                    solstart=1
                if j.find('( ALL  0.00000000 )')!=-1:
                    allzero=1
                if solstart==1:
                    for jj in range(nvar):
                        if (allzero==0) & (varfound[jj]==0):
                            if j.find((',    '+str(jj+1)+' '))!=-1:
                                varsplit=j.split((',    '+str(jj+1)+' '))[1]
                                if varsplit.find(','):
                                    varsplit=varsplit.split(',')[0]
                                else:
                                    varsplit.replace('\n','')
                                varsplit=varsplit.replace(' ','')
                                x[jj]=float(varsplit)
                                varfound[jj]=1
                            elif j.split(' ')[0]==str(jj+1):
                                for ind,jjj in enumerate(j.split(' ')):
                                    if (ind!=0) & (jjj!=''):
                                        varsplit=jjj.replace(',','').replace('\n','')
                                        x[jj]=float(varsplit)
                                        varfound[jj]=1
                                        break
                # find objective function value:
                if j.find('VARIABLE obj.L')!=-1:
                    solstart=0
                    eqsplit=j.split('=')[1].replace(' ','')
                    objstr=eqsplit.replace('\n','')
                # find time:
                if (j.find('Total time (sec.)')!=-1) & (timefound==0):
                    timefound=1
                    tsplit=j.split(':')[1].replace(' ','').replace('\n','')

            f2.write('modelstatus = ')
            f2.write(str(modelstatus))
            f2.write('\n')

            for j in range(len(x)):
                f2.write('x(')
                f2.write(str(j+1))
                f2.write(') = ')
                f2.write(str(x[j]))
                f2.write('\n')

            f2.write('obj = ')
            f2.write(objstr)
            f2.write('\n')

            if modelstatus==-3:
                f2.write('infeas = 1\n')
            else:
                f2.write('infeas = 0\n')

            if (modelstatus==0) | (modelstatus==1):
                f2.write('nonopt = 0\n')
            else:
                f2.write('nonopt = 1\n')

            f2.write('time = ')
            f2.write(tsplit)
            f2.write('\n')
            
            f2.close()

if __name__=='__main__':
  analyze(sys.argv)
