
"""
solve script for minos, also callable from system
"""

import sys
import os
import shutil
import subprocess

def solve(argv):
    """
    solve script for minos, arguments:
    <sourcedir> <targetdir> <plistfile> <solverdir> <languagedir> <timeout> <strategy>
    """
    scriptname=argv[0]
    sourcedir=argv[1]
    targetdir=argv[2]
    plistfile=argv[3]
    solverdir=argv[4]
    languagedir=argv[5]
    if len(argv)>6: timeout=argv[6]
    else: timeout='1e6'
    if len(argv)>7: strategy=argv[7]
    else: strategy=''
    # print("->",scriptname," <X> ",sourcedir," <X> ",targetdir," <X> ",plistfile," <X> ",solverdir," <X> ",languagedir," <X> ",timeout," <X> ",strategy)
    try:
        f=open(os.path.join(sourcedir,plistfile),'r')
    except IOError, errmsg:
        print errmsg
    lines=f.readlines()
    f.close()

    for i in lines:
        if i.find('.gms')!=-1:
            filein=i.replace('\n','')
            filetmp=filein.replace('.gms','_tmp.gms')
            filetmpopt=os.path.join(sourcedir,'minos.opt')
            fileout=os.path.join(targetdir,os.path.basename(i).replace('.gms','.lst'))
            fileout=fileout.replace('\n','')
            
            f2=open(filetmpopt,'w')
            f2.write('\n\n')
            f2.close()

            f2=open(filetmp,'w')
            f2.write('\noptions nlp = minos, dnlp = minos, decimals = 8, limrow = 0, limcol = 0, sysout = on, optca=1e-6, optcr=0, reslim=')
            f2.write(timeout)
            f2.write(';\n\n')
            f3=open(filein,'r')
            f3lines=f3.readlines()
            f3.close()
            isminlp=0
            for j in f3lines:
                f2.write(j)
                if str.lower(j).find('solve m using minlp')!=-1:
                    isminlp=1
            f2.close()

            if isminlp==0:
                comm=''
                commstrlist=[]
                commstrlist.append(os.path.join(languagedir,'gams'))
                commstrlist.append(' "')
                commstrlist.append(filetmp)
                commstrlist.append('" -o "')
                commstrlist.append(fileout)
                commstrlist.append('"')
                comm=comm.join(commstrlist)

                cwd=os.getcwd()
                os.chdir(sourcedir)
                retcode=subprocess.call(comm,shell=True)
                os.chdir(cwd)
            else:
                f4=open(fileout,'w')
                for j in f3lines:
                    f4.write(j)
                f4.write('\n\n**** minlp is not supported by minos.\n')
                f4.close()

            os.remove(filetmpopt)
            os.remove(filetmp)

if __name__=='__main__':
  solve(sys.argv)
